## ntpsec 1.2.2+dfsg1

=== wscript ===
from __future__ import print_function

from datetime import datetime
import itertools
import os
import shlex
import sys
import time

from waflib import Build
from waflib import Context
from waflib import Scripting
from waflib import Utils
from waflib.Build import (BuildContext, CleanContext, InstallContext,
                          StepContext, ListContext)
from waflib.Context import BOTH
from waflib.Errors import WafError
from waflib.Logs import pprint
from waflib.Tools import waf_unit_test

# Avoid writing .pyc files in wafhelpers/
sys.dont_write_bytecode = True

from wafhelpers.options import options_cmd
from wafhelpers.probes import probe_header, probe_function
from wafhelpers.test import test_write_log, test_print_log


pprint.__doc__ = None

APPNAME = 'ntpsec'

out = "build"

config = {
    "out": out,
    "OPT_STORE": {}
}


def help(ctx):
    "Be helpful, give a usage"
    print('''
Usage: waf <command>
    build       Build the project
    check       Run tests
    configure   Configure the project
    dist        Create a release
    install     Install the project
    loccount    Show SLOC count of the source tree
    uninstall   Uninstall the project

''')


def options(ctx):
    options_cmd(ctx, config)
    ctx.load('asciidoc', tooldir='wafhelpers/')
    ctx.recurse("pylib")


def configure(ctx):
    ctx.load('asciidoc', tooldir='wafhelpers/')

    class oc(Build.BuildContext):
        cmd = 'oc'

        def exec_command(self, cmd, **kw):
            kw['output'] = BOTH
            try:
                err, out = self.cmd_and_log(cmd, **kw)
            except WafError as e:
                self.logger.debug('WafError')
                return e.returncode
            if (len(out) and any(word in out for word
                                 in ['err', 'err:', 'error', 'error:',
                                     'ignored', 'illegal', 'unknown',
                                     'unrecognized', 'warning'])):
                self.logger.debug('noooo %r' % out)
                return 1
            if err:
                self.logger.debug('noooo %r' % err)
                return 1
            return 0

    def msg(str):
        pprint("YELLOW", str)

    def msg_setting(name, val):
        pprint("NORMAL", "  %-30s: " % name, sep="")
        pprint("YELLOW", val)

    srcnode = ctx.srcnode.abspath()
    bldnode = ctx.bldnode.abspath()

    ctx.run_build_cls = 'check'
    ctx.load('waf', tooldir='wafhelpers/')
    ctx.load('waf_unit_test')
    ctx.load('gnu_dirs')

    with open("VERSION", "r") as f:
        ntpsec_release = f.read().split(" ")[0].strip()

    ctx.env.OPT_STORE = config["OPT_STORE"]

    opt_map = {}
    # Wipe out and override flags with those from the commandline
    for flag in ctx.env.OPT_STORE:
        if flag == "--undefine":
            for sym in ctx.env.OPT_STORE[flag]:
                ctx.undefine(sym)
        elif flag == "--define":
            for symval in ctx.env.OPT_STORE[flag]:
                (sym, val) = symval.split("=")
                try:
                    ctx.define(sym, int(val))
                except ValueError:
                    ctx.define(sym, val)
        else:
            opt = flag.replace("--", "").upper()
            opt_map[opt] = ctx.env.OPT_STORE[flag]

    ctx.env['ntpc'] = ctx.options.enable_pylib
    ctx.env['ntpcver'] = '1.1.0'

    msg("--- Configuring host ---")
    ctx.setenv('host', ctx.env.derive())

    ctx.load('compiler_c')
    ctx.start_msg('Checking compiler version')
    ctx.end_msg("%s" % ".".join(ctx.env.CC_VERSION))

    # Some distros do not have /sbin in the PATH for non-root users.  We honor
    # the real PATH first, but append the sbin directories.
    ctx.find_program(
        "ldconfig", var="BIN_LDCONFIG", mandatory=False,
        path_list=(os.environ.get('PATH','').split(os.pathsep) +
            ["/sbin", "/usr/sbin", "/usr/local/sbin"]))

    # Ensure m4 is present, or bison will fail with SIGPIPE
    ctx.find_program('m4')
    ctx.load('bison')

    for opt in opt_map:
        ctx.env[opt] = opt_map[opt]

    if ctx.options.enable_rtems_trace:
        ctx.find_program("rtems-tld", var="BIN_RTEMS_TLD",
                         path_list=[ctx.options.rtems_trace_path,
                                    '${BINDIR}'])
        ctx.env.RTEMS_TEST_ENABLE = True
        ctx.env.RTEMS_TEST_FLAGS = [
            "-C", "%s/devel/trace/ntpsec-trace.ini" % srcnode,
            "-W", "%s/ntpsec-wrapper" % bldnode,
            "-P", "%s/devel/trace/" % srcnode,
            "-f", "-I%s" % bldnode,
            "-f", "-I%s/include/" % srcnode,
        ]

    # Not needed to build.  Used by utility scripts.
    ctx.find_program("awk", var="BIN_AWK", mandatory=False)
    ctx.find_program("sh", var="BIN_SH", mandatory=False)

    ctx.check_cfg(
        package='systemd', variables=['systemdsystemunitdir'],
        uselib_store='SYSTEMD', mandatory=False,
        msg="Checking for systemd")
    if ctx.env.SYSTEMD_systemdsystemunitdir:
        ctx.start_msg("systemd unit directory:")
        ctx.end_msg(ctx.env.SYSTEMD_systemdsystemunitdir)

    ctx.env.BIN_GIT = False
    if os.path.exists(".git"):
        ctx.find_program("git", var="BIN_GIT", mandatory=False)

    build_desc = ctx.options.build_desc.strip()
    if build_desc:
        build_desc = ' ' + build_desc
    if ctx.env.BIN_GIT:
        # 'tag', '7', and 'deadbeef' are fill ins for
        # a previous tag (always dropped), commits since that tag,
        # the short commit hash. I can see 5 'git describe' outputs
        # buildbots and prepush should get: tag-7-gdeadbeef
        # working developers should get: tag-7-gdeadbeef-dirty
        # patched shallow builders should get: gdeadbeef-dirty
        # other shallow builder should get: gdeadbeef
        # the thorium poisoned get errors and burst into flame
        # 1-2 tokens gets appended verbatim
        # 3-4 gets the first token dropped and the rest added
        # I have never seen 5+ tokens, we should be safe
        cmd = ctx.env.BIN_GIT + shlex.split("describe --tags --dirty --always")
        git_short_hash = ctx.cmd_and_log(cmd).strip().split('-')
        clip = 1 if len(git_short_hash) > 2 else 0
        git_short_hash = '-'.join(git_short_hash[clip:])

        ctx.env.NTPSEC_VERSION = "%s+" % ntpsec_release
        ctx.env.NTPSEC_VERSION_EXTENDED = ("%s+%s%s" %
                                           (ntpsec_release,
                                            git_short_hash,
                                            build_desc))
    else:
        ctx.env.NTPSEC_VERSION = "%s" % ntpsec_release
        ctx.env.NTPSEC_VERSION_EXTENDED = ("%s%s" % (ntpsec_release,
                                                      build_desc))
    ctx.define("NTPSEC_VERSION", ctx.env.NTPSEC_VERSION)
    ctx.define("NTPSEC_VERSION_EXTENDED", ctx.env.NTPSEC_VERSION_EXTENDED)

    # We require some things that C99 doesn't enable, like pthreads.
    # These flags get propagated to both the host and main parts of the build.
    #
    # _POSIX_C_SOURCE
    #      If ==1, like _POSIX_SOURCE;
    #      if >=2 add IEEE Std 1003.2;
    #      if >=199309L, add IEEE Std 1003.1b-1993;
    #      if >=199506L, add IEEE Std 1003.1c-1995;
    #      if >=200112L, all of IEEE 1003.1-2004
    #      if >=200809L, all of IEEE 1003.1-2008
    #
    # FIXME: We'd like this to be -D_POSIX_C_SOURCE=200809L -D_XOPEN_SOURCE=700
    # rather than -D_GNU_SOURCE, but that runs into problems in two places:
    # (1) The ISC net handling stuff, where struct in6_addr’ loses a member
    # named s6_addr32 that the macros need, and (2) three BSD functions
    # related to chroot jailing in the sandbox code.
    #
    # Note that _POSIX_C_SOURCE >= 199506L and _GNU_SOURCE both turn on
    # _POSIX_PTHREAD_SEMANTICS and _REENTRANT
    #
    ctx.env.CFLAGS = ["-std=c99", "-D_GNU_SOURCE"] + ctx.env.CFLAGS

    msg("--- Configuring main ---")
    ctx.setenv("main", ctx.env.derive())

    from wafhelpers.check_sizeof import check_sizeof

    for opt in opt_map:
        ctx.env[opt] = opt_map[opt]

    if ctx.options.cross_compiler:
        ctx.env.ENABLE_CROSS = True

        ctx.start_msg("Using Cross compiler CC:")
#           ctx.get_cc_version(ctx.env.CC, gcc=True)
        ctx.end_msg(ctx.options.cross_compiler)

        ctx.env.CC = shlex.split(ctx.options.cross_compiler)
        ctx.env.LINK_CC = shlex.split(ctx.options.cross_compiler)

        if ctx.env["CROSS-CFLAGS"]:
            # Lexically split each part of the CFLAGS, then chain the lists
            iter = [shlex.split(x) for x in opt_map["CROSS-CFLAGS"]]
            ctx.env.CFLAGS = list(itertools.chain.from_iterable(iter))

        if ctx.env["CROSS-LDFLAGS"]:
            # Lexically split each part of the LDFLAGS, then chain the lists
            iter = [shlex.split(x) for x in opt_map["CROSS-LDFLAGS"]]
            ctx.env.LDFLAGS = list(itertools.chain.from_iterable(iter))

    if ctx.options.list:
        from wafhelpers.refclock import refclock_map
        print("ID    Description")
        print("~~    ~~~~~~~~~~~")
        for id in refclock_map:
            print("%-5s %s" % (id, refclock_map[id]["descr"]))

        return

    # These are required by various refclocks
    # needs to be tested before CFLAGS are set
    if ctx.check_endianness() == "big":
        ctx.define("WORDS_BIGENDIAN", 1)

    if ctx.options.enable_leap_testing:
        ctx.define("ENABLE_LEAP_TESTING", 1,
                   comment="Enable leap seconds on other than 1st of month.")

    # check for some libs first.  some options, like stack protector,
    # may depend on some libs, like -lssp
    ctx.check_cc(lib="m", comment="Math library")
    ctx.check_cc(lib="rt", mandatory=False, comment="realtime library")
    ctx.check_cc(lib="pthread", mandatory=False, comment="threads library")
    ctx.check_cc(lib="execinfo", mandatory=False,
                 comment="BSD backtrace library")
    ret = ctx.check_cc(lib="bsd", mandatory=False,
                       comment="BSD compatibility library")
    if ret:
        ctx.env.LDFLAGS += ["-lbsd"]

    # -lssp and -lssp_nonshared may be needed by older gcc to
    # support "-fstack-protector-all"
    ret = ctx.check_cc(lib="ssp", mandatory=False,
                       comment="libssp")
    if ret:
        ctx.env.LDFLAGS += ["-lssp"]

    ret = ctx.check_cc(lib="ssp_nonshared", mandatory=False,
                       comment="libssp_nonshared")
    if ret:
        ctx.env.LDFLAGS += ["-lssp_nonshared"]

    cc_test_flags = [
        ('f_stack_protector_all', '-fstack-protector-all'),
        ('PIC', '-fPIC'),
        ('PIE', '-pie -fPIE'),
        # this quiets most of macOS warnings on -fpie
        ('unused', '-Qunused-arguments'),
        # This is a useless warning on any architecture with a barrel
        # shifter, which includes Intel and ARM and basically
        # everything nowadays. Even so, we'd enable it out of
        # perfectionism, but the GCC directives that ought to be
        # useful for forcing structure alignment in order to suppress
        # it locally don't seem to be working quite right.
        # ('w_cast_align', "-Wcast-align"),
        ('w_cast_qual', "-Wcast-qual"),
        ('w_disabled_optimization', "-Wdisabled-optimization"),
        ('w_float_equal', "-Wfloat-equal"),
        ('w_format', '-Wformat'),
        ('w_format_security', '-Wformat-security'),
        # fails on OpenBSD 6
        ('w_format_signedness', '-Wformat-signedness'),
        ('w_implicit_function_declaration', "-Wimplicit-function-declaration"),
        ('w_init_self', '-Winit-self'),
        ('w_invalid_pch', '-Winvalid-pch'),
        ('w_missing_declarations', '-Wmissing-declarations'),
        ('w_multichar', '-Wmultichar'),
        ('w_packed', '-Wpacked'),
        ('w_pointer_arith', '-Wpointer-arith'),
        ('w_shadow', '-Wshadow'),
        # fails on clang

=== attic/wscript ===
def build(ctx):
    util = [	'sht',
		'digest-find', 'clocks', "random",
		'digest-timing', 'cmac-timing',
		'backwards']

    for name in util:
        ctx(
            target=name,
            features="c cprogram",
            includes=[ctx.bldnode.parent.abspath(), "../include"],
            source=[name + ".c"],
            use="ntp M CRYPTO RT PTHREAD",
            install_path=None,
        )

=== libaes_siv/wscript ===
def build(ctx):
    aes_cflags=['-Wno-shadow',
            # '-Wall', '-Wextra', '-Wstrict-prototypes',  # default
            '-Wconversion',
            '-O3',
            '-fomit-frame-pointer',
            '-funroll-loops',
            '-ftree-vectorize',
            '-Wno-inline',  # gcc 10 gives inline warnings?
            ]


    ctx(
        target='aes_siv',
        features='c cstlib',
        includes=[ctx.bldnode.parent.abspath()],
        source='aes_siv.c',
        use='CRYPTO',
        cflags=aes_cflags,
    )

    ctx(
        target="runtests",
        features="c cprogram test",
        includes=[ctx.bldnode.parent.abspath()],
        source=[
            "aes_siv_test.c",
            "tests.c",
        ],
        use="aes_siv",
        cflags=aes_cflags,
    )

=== libntp/wscript ===
import os

import waflib
from waflib import Errors, Options
from waflib.Logs import pprint

def build(ctx):

    libntp_source = [
        "authkeys.c",
        "authreadkeys.c",
        "clocktime.c",
        "decodenetnum.c",
        "dolfptoa.c",
        "getopt.c",
        "initnetwork.c",
        "isc_interfaceiter.c",
        "isc_net.c",
        "macencrypt.c",
        "ntp_endian.c",
        "numtoa.c",
        "refidsmear.c",
        "socket.c",
        "socktoa.c",
        "ssl_init.c",
        "syssignal.c",
    ]

    libntp_source_sharable = [
        "assert.c",
        "clockwork.c",
        "emalloc.c",
        "hextolfp.c",
        "lib_strbuf.c",
        "msyslog.c",
        "ntp_calendar.c",
        "ntp_random.c",
        "prettydate.c",
        "statestr.c",
        "systime.c",
        "timespecops.c",
    ]

    if not ctx.env.HAVE_STRLCAT or not ctx.env.HAVE_STRLCPY:
        libntp_source_sharable += ["strl_obsd.c"]

    # C library
    ctx(
        features="c cstlib",
        includes=[ctx.bldnode.parent.abspath(), "../include"],
        source=libntp_source + libntp_source_sharable,
        target="ntp",
        use="CRYPTO SSL",
    )

    if ctx.env['ntpc'] == 'ffi':
        # Loadable FFI stub
        ctx(
            features="c cshlib",
            includes=[ctx.bldnode.parent.abspath(), "../include"],
            source=["ntp_c.c", "pymodule-mac.c"] + libntp_source_sharable,
            target="../pylib/ntpc",  # Put the output in the pylib directory
            use="M RT CRYPTO",
            vnum=ctx.env['ntpcver'],
        )
        ctx.add_post_fun(post)
    elif ctx.env['ntpc'] == 'ext':
        # Loadable Python extension
        ctx(
            features="c cshlib pyext",
            install_path='${PYTHONARCHDIR}/ntp',
            includes=[ctx.bldnode.parent.abspath(), "../include"],
            source=["pymodule.c", "pymodule-mac.c"] + libntp_source_sharable,
            target="../pylib/ntpc",  # Put the output in the pylib directory
            use="M RT CRYPTO",
        )

def post(ctx):
    if not (ctx.cmd == 'install' and ctx.env.BIN_LDCONFIG):
        return

    destdir = Options.options.destdir
    if destdir:
        # When --destdir is set, we are by definition not installing to the
        # real location, so running ldconfig is pointless.  It will need to
        # be run manually by the user (or the package install process, if
        # this is a package build).
        pprint("YELLOW", "WARNING:")
        pprint("YELLOW", "WARNING: Run ldconfig manually.")
        pprint("YELLOW", "WARNING:")
        return

    # Try to run ldconfig.  It is not a fatal error here if it fails, as the
    # install could be run by a non-root user.
    ldconfig = ' '.join(ctx.env.BIN_LDCONFIG)
    try:
        out = ctx.cmd_and_log(
            ctx.env.BIN_LDCONFIG, output=waflib.Context.STDOUT,
            quiet=waflib.Context.BOTH)
        pprint("GREEN", "running: %s  OK" % ldconfig)
    except Errors.WafError as e:
        pprint("RED", "running: %s  FAILED" % ldconfig)
        if e.stdout:
            pprint("RED", e.stdout)
        if e.stderr:
            pprint("RED", e.stderr)

=== ntpd/wscript ===

def build(ctx):
    bldnode = ctx.bldnode.abspath()

    if ctx.variant == "host":
        bison_source = ["ntp_parser.y"]

        ctx(
            features="c",
            includes=[ctx.bldnode.parent.abspath(), "../include", "."],
            source=bison_source,
            target="bison_obj",
        )

        # Generate Bison file first.
        ctx.add_group()

        keyword_gen_source = ["keyword-gen.c", ]

        ctx(
            features="c cprogram",
            includes=[ctx.bldnode.parent.abspath(), "../include", "."],
            install_path=None,
            source=keyword_gen_source,
            target="keyword-gen",
        )

        # XXX: needs a dependency to rebuild ntp_keyword.h
        #      when keyword-gen is rebuilt

        # Make sure keyword-gen is created next.
        ctx.add_group()

        ctx(
            features="c",
            rule="%s/ntpd/keyword-gen ${SRC} > ${TGT}" % bldnode,
            source="ntp_parser.tab.h",
            target="ntp_keyword.h"
        )

        # Make sure ntp_keyword.h is created last.
        ctx.add_group()

        return

    libntpd_source = [
        "ntp_control.c",
        "ntp_filegen.c",
        "ntp_leapsec.c",
        "ntp_monitor.c",    # Needed by the restrict code
        "ntp_recvbuff.c",
        "ntp_restrict.c",
        "ntp_util.c",
    ]

    if not ctx.env.DISABLE_NTS:
      libntpd_source += [
        "nts.c",
        "nts_server.c",
        "nts_client.c",
        "nts_cookie.c",
        "nts_extens.c",
    ]

    ctx(
        features="c",
        includes=[ctx.bldnode.parent.abspath(), "../include", "../libaes_siv"],
        source=libntpd_source,
        target="libntpd_obj",
        use="CRYPTO aes_siv",
    )

    ctx(
        target="ntpd_lib",
        features="c cstlib",
        use="libntpd_obj",
        # use="libntpd_obj bison_obj",
    )

    use_refclock = ""      # XXX: there must be a better way to do this
    if ctx.env.REFCLOCK_ENABLE:

        refclock_source = ["ntp_refclock.c",
                           "refclock_conf.c"
                           ]

        ctx(
            target="refclock",
            features="c",
            includes=[ctx.bldnode.parent.abspath(), "../include"],
            source=refclock_source,
        )
        use_refclock += "refclock"

        for file, define in ctx.env.REFCLOCK_SOURCE:
            ctx(
                defines=["%s=1" % define],
                features="c",
                includes=[ctx.bldnode.parent.abspath(), "../include", "../libjsmn"],
                # XXX: These need to go into config.h
                #      rather than the command line for the individual drivers
                source="refclock_%s.c" % file,
                target="refclock_%s" % file,
            )
            use_refclock += " refclock_%s" % file

    ntpd_source = [
        "ntp_config.c",
        "ntp_io.c",
        "ntp_loopfilter.c",
        "ntp_packetstamp.c",
        "ntp_peer.c",
        "ntp_proto.c",
        "ntp_sandbox.c",
        "ntp_scanner.c",
        "ntp_signd.c",
        "ntp_timer.c",
        "ntp_dns.c",
        "ntpd.c",
        ctx.bldnode.parent.find_node("host/ntpd/ntp_parser.tab.c")
    ]

    ctx(
        features="c rtems_trace cprogram",
        includes=[
            ctx.bldnode.parent.abspath(), "../include",
            "%s/host/ntpd/" % ctx.bldnode.parent.abspath(), "." ],
        install_path='${SBINDIR}',
        source=ntpd_source,
        target="ntpd",
        use="libntpd_obj ntp M parse RT CAP SECCOMP PTHREAD NTPD "
            "CRYPTO SSL DNS_SD %s SOCKET NSL SCF" % use_refclock,
    )

    ctx.manpage(8, "ntpd-man.adoc")
    ctx.manpage(5, "ntp.conf-man.adoc")
    ctx.manpage(5, "ntp.keys-man.adoc")

=== pylib/wscript ===
from waflib.Logs import pprint


def options(opt):
    opt.load('python')


def configure(conf):
    conf.load('python')
    if not conf.env.ENABLE_CROSS:
        conf.check_python_version((2, 6, 0))
    conf.check_python_headers(features='pyext')  # Extension-only, no embedded
    try:
        conf.check_python_module('curses')
        conf.env['PYTHON_CURSES'] = True
    except conf.errors.ConfigurationError:
        pprint("YELLOW", "WARNING: ntpmon will not be built/installed since "
               "python curses module was not found")
    try:
        conf.check_python_module('argparse')
        conf.env['PYTHON_ARGPARSE'] = True
    except conf.errors.ConfigurationError:
        pprint("YELLOW", "WARNING: ntploggps, ntplogtemp, and ntpviz will not "
               "be built/installed since python argparse module was not found")
    try:
        conf.check_python_module('gps', condition="ver >= num(3, 18)")
        conf.env['PYTHON_GPS'] = True
    except conf.errors.ConfigurationError:
        pprint("YELLOW", "WARNING: ntploggps will not be built/installed since "
               "python gps module >= 3.18 was not found")


def build(ctx):
    srcnode = ctx.srcnode.make_node('pylib')
    bldnode = ctx.bldnode.make_node('pylib')
    target1 = bldnode.make_node('control.py')
    target2 = bldnode.make_node('magic.py')

    sources = []
    if ctx.env['ntpc'] == 'ext':
        sources = srcnode.ant_glob("*.py", excl='ntpc.py')
    elif ctx.env['ntpc'] == 'ffi':
        sources = srcnode.ant_glob('*.py')
    builds = [x.get_bld() for x in sources]

    # The rm's here were added to fix a reported (but underdocumented) problem
    # where the results of pythonize-header were not updated when needed,
    # though there is as yet no explanation for why this had occurred, and the
    # alleged failure only occurred when changing the code between 'configure'
    # and 'build', which is not a legal action, anyway.
    # These rm's were causing unnecessary reruns of pythonize-header,
    # including during 'install'. They are now disabled but retained as a
    # comment.

    ## Remove generated files to ensure they are properly updated
    #ctx.exec_command("rm -f %s" % target1.abspath())
    #ctx.exec_command("rm -f %s" % target2.abspath())

    if ctx.env['ntpc'] is None:
        return
        
    # Make sure Python sees .py as well as .pyc/.pyo
    ctx(
        features="subst",
        source=sources,
        target=builds,
    )

    ctx(
        before=['pyc', 'pyo'],
        cwd=srcnode,
        rule='${PYTHON} ${SRC} >${TGT}',
        source=["../wafhelpers/pythonize-header", "../include/ntp_control.h"],
        target=target1,
    )

    ctx(
        before=['pyc', 'pyo'],
        cwd=srcnode,
        rule='${PYTHON} ${SRC} >${TGT}',
        source=["../wafhelpers/pythonize-header", "../include/ntp.h"],
        target=target2,
    )

    # Force early creation of generated files
    ctx.add_group()

    ctx(
        features='py',
        source=builds+[target1, target2],
        install_from=bldnode,
        install_path='${PYTHONARCHDIR}/ntp'
    )

    # pep241  lay an egg
    egg = ['ntp-%s.egg-info' % ctx.env.NTPSEC_VERSION]
    ctx(
        features="subst",
        source=['ntp-in.egg-info'],
        target=egg
    )
    ctx.install_files(ctx.env.PYTHONARCHDIR, egg)

=== debian/changelog ===
ntpsec (1.2.2+dfsg1-4build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 18:02:43 +1100

ntpsec (1.2.2+dfsg1-4build1) noble; urgency=medium

  * No-change rebuild against libssl3t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 04 Mar 2024 20:12:18 +0000

ntpsec (1.2.2+dfsg1-4) unstable; urgency=medium

  [ Richard Laager ]
  * Check before calling addgroup/adduser.
    Thanks to Bob Proulx <bob@proulx.com> (Closes: 1058961)
  * Fix Python escape sequence warnings.
    Thanks to Matt Selsky (Closes: 1058060)

  [ Michael Biebl ]
  * Move NetworkManager hook scripts to /usr/lib (Closes: 1053108)

  [ Santiago Vila ]
  * Downgrade missing stats dir log severity (Closes: 1049424)

  [ Richard Laager ]
  * Fix duplicate exit status in man pages (Closes: 1053722)

 -- Richard Laager <rlaager@debian.org>  Sun, 24 Dec 2023 16:30:01 -0600

ntpsec (1.2.2+dfsg1-3) unstable; urgency=high

  [ Helmut Grohne ]
  * Fix FTBFS when systemd.pc changes systemdsystemunitdir. (Closes: 1052664)

  [ Richard Laager ]
  * Fix corrupted ntpq output.
    Thanks to Hal Murray and Bill Sommerfeld (Closes: 1057416)

 -- Richard Laager <rlaager@debian.org>  Sun, 10 Dec 2023 22:02:20 -0600

ntpsec (1.2.2+dfsg1-2) unstable; urgency=high

  * copyright: Update libjsmn comment
  * copyright: Add minor details from upstream
  * Drop dependency on lsb-base
  * Fix file cleanup (Closes: 1036443, 1040354, 1040355)
  * Backport fix to restore blank lines in ntpq (Closes: 1038876)
  * apparmor: leap-seconds.list doesn't need "w"
    Thanks to Hal Murray
  * Fix IGNORE_DHCP comments.
    Thanks to Hal Murray
  * Fix cookie crash.
    Thanks to Hal Murray (Closes: 1038422)

 -- Richard Laager <rlaager@debian.org>  Sun, 30 Jul 2023 14:04:02 -0500

=== debian/control ===
Source: ntpsec
Section: net
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Richard Laager <rlaager@debian.org>
Build-Depends: asciidoctor,
               bison,
               debhelper-compat (= 13),
               dh-apache2,
               dh-apparmor,
               dh-python,
               docbook-xsl,
               libbsd-dev,
               libcap2-dev [linux-any],
               libssl-dev,
               netbase,
               pkg-config,
               pps-tools [linux-any],
               python3,
               python3-dev,
               python3-gps,
               systemd,
               xsltproc,
               xz-utils,
Build-Conflicts: libavahi-compat-libdnssd-dev,
                 libwww-dev,
                 libwww-ssl-dev,
Standards-Version: 4.6.2
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/debian/ntpsec
Vcs-Git: https://salsa.debian.org/debian/ntpsec.git
Homepage: https://www.ntpsec.org

Package: ntpsec
Architecture: any
Pre-Depends: ${misc:Pre-Depends},
Depends: adduser,
         netbase,
         python3,
         python3-ntp (= ${binary:Version}),
         tzdata,
         ${misc:Depends},
         ${shlibs:Depends},
Recommends: systemd | cron | cron-daemon,
Suggests: apparmor,
          certbot,
          ntpsec-doc,
          ntpsec-ntpviz,
Breaks: ntp (<< 1:4.2.8p15+dfsg-2~),
Conflicts: time-daemon,
Provides: time-daemon,
Replaces: ntp (<< 1:4.2.8p15+dfsg-2~),
          time-daemon,
Description: Network Time Protocol daemon and utility programs
 NTP, the Network Time Protocol, is used to keep computer clocks
 accurate by synchronizing them over the Internet or a local network,
 or by following an accurate hardware receiver that interprets GPS,
 DCF-77, or similar time signals.
 .
 This package contains the NTP daemon and utility programs.  An NTP
 daemon needs to be running on each host that is to have its clock
 accuracy controlled by NTP.  The same NTP daemon is also used to
 provide NTP service to other hosts.
 .
 This is the NTPsec version of NTP.  NTPsec is a secure, hardened,
 and improved implementation derived from the original NTP project.
 NTPsec supports Network Time Security (NTS) which provides
 cryptographically authenticated time.
 .
 For more information about the NTP protocol and NTP server
 configuration and operation, install the package "ntpsec-doc".

Package: ntpsec-ntpdate
Architecture: any
Depends: netbase,
         ntpsec-ntpdig (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
Breaks: ntpdate (<< 1:4.2.8p15+dfsg-2~),
Replaces: ntpdate (<< 1:4.2.8p15+dfsg-2~),
Description: client for setting system time from NTP servers
 NTP, the Network Time Protocol, is used to keep computer clocks
 accurate by synchronizing them over the Internet or a local network,
 or by following an accurate hardware receiver that interprets GPS,
 DCF-77, or similar time signals.
 .
 ntpdate is a simple NTP client that sets a system's clock to match
 the time obtained by communicating with one or more NTP servers.  It
 is not sufficient, however, for maintaining an accurate clock in the
 long run.  ntpdate by itself is useful for occasionally setting the
 time on machines that do not have full-time network access, such as
 laptops.
 .
 This is the NTPsec version of ntpdate.  NTPsec is a secure, hardened,
 and improved implementation derived from the original NTP project.
 .
 If the full NTP daemon from the package "ntpsec" is installed, then
 ntpsec-ntpdate is not necessary.

Package: ntpsec-ntpdig
Architecture: any
Depends: python3 (>= 3.3),
         python3-ntp (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
Breaks: ntpsec-ntpdate (<< 1.2.1+dfsg1-5~),
        sntp (<< 1:4.2.8p15+dfsg-2~),
Replaces: ntpsec-ntpdate (<< 1.2.1+dfsg1-5~),
          sntp (<< 1:4.2.8p15+dfsg-2~),
Description: ntpdig SNTP client
 NTP, the Network Time Protocol, is used to keep computer clocks
 accurate by synchronizing them over the Internet or a local network,
 or by following an accurate hardware receiver that interprets GPS,
 DCF-77, or similar time signals.
 .
 ntpdig can be used as an SNTP client to query a NTP or SNTP server
 and either display the time or set the local system's time.  It is not
 sufficient, however, for maintaining an accurate clock in the long run.
 .
 This is the NTPsec version of ntpdig, which is equivalent to the sntp
 utility.  NTPsec is a secure, hardened, and improved implementation
 derived from the original NTP project.

Package: ntpsec-ntpviz
Architecture: any
Depends: adduser,
         fonts-liberation,
         gnuplot-nox | gnuplot,
         python3,
         python3-ntp (= ${binary:Version}),
         systemd | cron | cron-daemon,
         ${misc:Depends},
Recommends: ntpsec,
            systemd | python3-psutil,
            ${misc:Recommends},
Suggests: python3-gps,
Description: NTP statistics graphing utility
 NTP, the Network Time Protocol, is used to keep computer clocks
 accurate by synchronizing them over the Internet or a local network,
 or by following an accurate hardware receiver that interprets GPS,
 DCF-77, or similar time signals.
 .
 ntpviz analyzes NTP log files and generates statistical plots from
 them.  The output is in the form of HTML with images.  If Apache is
 installed, it will be served at: /ntpviz
 .
 This is part of NTPsec.  NTPsec is a secure, hardened, and improved
 implementation derived from the original NTP project.

Package: ntpsec-doc
Architecture: all
Depends: ${misc:Depends},
Breaks: ntp-doc (<< 1:4.2.8p15+dfsg-2~),
Replaces: ntp-doc (<< 1:4.2.8p15+dfsg-2~),
Section: doc
Multi-Arch: foreign
Description: Network Time Protocol documentation
 NTP, the Network Time Protocol, is used to keep computer clocks
 accurate by synchronizing them over the Internet or a local network,
 or by following an accurate hardware receiver that interprets GPS,
 DCF-77, or similar time signals.
 .
 This package contains HTML documentation for the ntpsec packages (ntpsec,
 ntpsec-ntpdate).
 .
 This is part of NTPsec.  NTPsec is a secure, hardened, and improved
 implementation derived from the original NTP project.

Package: python3-ntp
Architecture: any
Depends: python3,
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends},
Provides: ${python3:Provides},
Section: python
Description: Python 3 NTP Helper Classes
 NTP, the Network Time Protocol, is used to keep computer clocks
 accurate by synchronizing them over the Internet or a local network,
 or by following an accurate hardware receiver that interprets GPS,
 DCF-77, or similar time signals.
 .
 This package contains the Python "ntp" module, which contains helper
 classes for NTP utilities written in Python.
 .
 This is part of NTPsec.  NTPsec is a secure, hardened, and improved
 implementation derived from the original NTP project.

Package: ntp
Architecture: all
Section: oldlibs
Depends: ntpsec,
         ${misc:Depends},
Description: Network Time Protocol daemon/utilities (transitional package)
 This is a dummy transitional package to transition to NTPsec.
 It can be safely removed.

Package: ntp-doc
Architecture: all
Section: oldlibs
Depends: ntpsec-doc,
         ${misc:Depends},
Description: Network Time Protocol docs (transitional package)
 This is a dummy transitional package to transition to NTPsec.
 It can be safely removed.

Package: ntpdate
Architecture: all
Section: oldlibs
Depends: ntpsec-ntpdate,
         ${misc:Depends},
Description: Network Time Protocol client (transitional package)
 This is a dummy transitional package to transition to NTPsec.
 It can be safely removed.

Package: sntp
Architecture: all
Section: oldlibs
Depends: ntpsec-ntpdig,
         ${misc:Depends},
Description: Network Time Protocol client (transitional package)
 This is a transitional package to transition to NTPsec.
 It can be safely removed once all uses of sntp(1) have been converted to
 run ntpdig instead.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/default.mk
include /usr/share/dpkg/pkg-info.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow,+pie
export DEB_CFLAGS_MAINT_APPEND = -fno-strict-aliasing
export systemdsystemunitdir = $(shell pkg-config --variable=systemdsystemunitdir systemd)

%:
	dh $@ --with apache2,python3

override_dh_auto_configure:
ifeq (hurd, $(DEB_HOST_ARCH_OS))
	# hurd does not provided the system calls needed for ntpd to work.
	exit 1
endif
	# Only build with refclocks NOT slated for removal.  See also
	# debian/patches/update-refclock-docs.patch.  However, if the reason
	# for deprecation is only "two digit years", I *am* keeping it.
	#
	# Upstream references:
	# https://www.ntpsec.org/removal-plan.html
	# https://www.ntpsec.org/drivers.html
	#
	# Also drop modem.  It "requires a Hayes-compatible 1200bps modem,
	# hardware now 20 years obsolete".
	#
	# gpsd is a tough call.  It's not deprecated upstream, and it still can
	# work.  However, upstream recommends the use of SHM, as does every
	# example HOWTO I found with a quick search.  Furthermore, it is buggy:
	#   https://lists.ntpsec.org/pipermail/devel/2016-October/002392.html
	# Also, it "makes all sorts of non-standard assumptions about how gpsd
	# is configured.  A configuration that is contorted and non-obvious":
	#   https://lists.ntpsec.org/pipermail/devel/2016-October/002422.html
	# Most importantly, it is an attractive nuisance.  If someone is told
	# that the best practice is to use "gpsd", they might logically think
	# they should use the gpsd driver.  Skipping the gpsd driver also avoids
	# using the embedded copy of libjsmn.
	#
	# We pass LDFLAGS as LINKFLAGS because LINKFLAGS appears first in the
	# command line.  Debian wants to build with -fPIE for security reasons.
	# This is not compatible with building shared libraries like the ntpc
	# python extension.  If the -fPIE flag comes before -shared (or -fPIC),
	# the latter will override, and the build succeeds.
	CFLAGS='$(CFLAGS) $(CPPFLAGS)' \
	LDFLAGS='' \
	LINKFLAGS='$(LDFLAGS)' \
		python3 waf configure \
		--pyshebang=/usr/bin/python3 \
		--prefix=/usr --libdir=/usr/lib/$(DEB_HOST_MULTIARCH) \
		--enable-debug --enable-debug-gdb \
		--enable-mssntp --enable-warnings \
		--refclock=local,spectracom,generic,arbiter,nmea,pps,hpgps,shm,trimble,jjy,zyfer \
		--enable-doc --htmldir=/usr/share/doc/ntpsec/html

override_dh_auto_build:
	python3 waf build -v

override_dh_auto_clean:
	python3 waf clean || true
	rm -rf \
		build \
		.lock-waf_*_build \
		ntpclients/ntp \
		ntpd/version.h \
		.waf* \
		wafhelpers/autorevision.sh
	find -name "*.pyc" -delete

override_dh_gencontrol:
	dh_gencontrol -pntp     -- -v1:4.2.8p15+dfsg-2~$(DEB_VERSION_UPSTREAM_REVISION)
	dh_gencontrol -pntp-doc -- -v1:4.2.8p15+dfsg-2~$(DEB_VERSION_UPSTREAM_REVISION)
	dh_gencontrol -pntpdate -- -v1:4.2.8p15+dfsg-2~$(DEB_VERSION_UPSTREAM_REVISION)
	dh_gencontrol -psntp    -- -v1:4.2.8p15+dfsg-2~$(DEB_VERSION_UPSTREAM_REVISION)
	dh_gencontrol --remaining-packages

override_dh_install:
	python3 waf install --destdir=$(CURDIR)/debian/tmp
	mv \
		debian/tmp/$(systemdsystemunitdir)/ntpd.service \
		debian/tmp/$(systemdsystemunitdir)/ntpsec.service
	mv \
		debian/tmp/$(systemdsystemunitdir)/ntp-wait.service \
		debian/tmp/$(systemdsystemunitdir)/ntpsec-wait.service
	rm -rf debian/tmp/usr/lib/python3/dist-packages/ntp/__pycache__
	# ntpfrob probes internal, mostly undocumented settings.  It is
	# extremely unlikely that anyone needs this.
	#
	# ntpsnmpd is experimental.  If support for it is desired, then
	# it can be installed, but it will require some patching of file
	# paths to be compliant with Debian best practices.  It also needs
	# more documentation on how to integrate with snmpd.
	#
	# From ntpsweep.1, "ntpsweep relies on ntpq and Mode 6 queries to
	# probe servers. This depends on the remote host's restrict
	# configuration allowing queries. Nowadays effectively all public
	# hosts set noquery, so this script is unlikely to be useful unless
	# you have multiple specially-configured timeservers on a LAN."  The
	# default ntp.conf from this package also sets "noquery" (with an
	# exception for localhost).
	rm \
		debian/tmp/usr/bin/ntpfrob \
		debian/tmp/usr/bin/ntpsnmpd \
		debian/tmp/usr/bin/ntpsweep \
		debian/tmp/usr/share/man/man1/ntpsweep.1 \
		debian/tmp/usr/share/man/man8/ntpfrob.8 \
	        debian/tmp/usr/share/man/man8/ntpsnmpd.8
	mv \
		debian/tmp/usr/bin/ntptime \
		debian/tmp/usr/bin/ntpkeygen \
		debian/tmp/usr/bin/ntploggps \
		debian/tmp/usr/bin/ntplogtemp \
		debian/tmp/usr/bin/ntpwait \
		debian/tmp/usr/sbin/
	install -m 755 \
		attic/ntpdate \
		debian/tmp/usr/sbin
	# Sometimes we get the timestamp from the tarball and sometimes we get
	# a more recent timestamp (probably build time?).  The latter gets
	# clamped to the debian/changelog timestamp when the .deb is built,
	# but the tarball timestamp does not (as it is older).  This forces
	# all the timestamps to be newer so they all get clamped.
	find $(CURDIR)/debian/tmp/usr/share/doc/ntpsec/html -type f \
		-exec touch {} \+

	install -d debian/ntpsec/etc/letsencrypt/renewal-hooks/deploy
	install -m 755 \
		debian/ntpsec.certbot \
		debian/ntpsec/etc/letsencrypt/renewal-hooks/deploy/ntpsec

	install -d debian/ntpsec/$(systemdsystemunitdir)
	install -m 644 \
		debian/ntpsec.ntpsec-rotate-stats.service \
		debian/ntpsec/$(systemdsystemunitdir)/ntpsec-rotate-stats.service
	install -m 644 \
		debian/ntpsec.ntpsec-rotate-stats.timer \
		debian/ntpsec/$(systemdsystemunitdir)/ntpsec-rotate-stats.timer

	install -d debian/ntpsec-ntpviz/$(systemdsystemunitdir)
	install -m 644 \
		etc/ntploggps.service \
		etc/ntploggps.timer \
		debian/ntpsec-ntpviz/$(systemdsystemunitdir)

	install -d debian/ntpsec-ntpviz/etc/ntpviz/day
	install -m 644 www/day/footer \
		debian/ntpsec-ntpviz/etc/ntpviz/day/footer.html
	install -m 644 www/day/header \
		debian/ntpsec-ntpviz/etc/ntpviz/day/header.html
	install -m 644 www/index.html \
		debian/ntpsec-ntpviz/etc/ntpviz/index.html
	install -m 644 debian/ntpviz.options \
		debian/ntpsec-ntpviz/etc/ntpviz/options
	install -d debian/ntpsec-ntpviz/etc/ntpviz/week
	install -m 644 www/week/footer \
		debian/ntpsec-ntpviz/etc/ntpviz/week/footer.html
	install -m 644 www/week/header \
		debian/ntpsec-ntpviz/etc/ntpviz/week/header.html

	install -d debian/ntpsec-ntpviz/usr/share/ntpsec-ntpviz/ntpviz
	install -m 644 \
		www/favicon.ico \
		www/ntpsec-logo.png \
		debian/ntpsec-ntpviz/usr/share/ntpsec-ntpviz/ntpviz

	install -D -m 0755 debian/ntpdate-debian \
		debian/ntpsec-ntpdate/usr/sbin/ntpdate-debian
	install -D -m 0644 debian/ntpsec.dhcp \
		debian/ntpsec/etc/dhcp/dhclient-exit-hooks.d/ntpsec
	install -D -m 0755 debian/ntpsec.networkmanager \
		debian/ntpsec/usr/lib/NetworkManager/dispatcher.d/ntpsec
	install -D -m 0644 debian/ntpsec-ntpdate.dhcp \
		debian/ntpsec-ntpdate/etc/dhcp/dhclient-exit-hooks.d/ntpsec-ntpdate
	install -D -m 0755 debian/ntpsec-ntpdate.networkmanager \
		debian/ntpsec-ntpdate/usr/lib/NetworkManager/dispatcher.d/ntpsec-ntpdate
	install -D -m 0644 debian/ntpsec-systemd-netif.path \
		debian/ntpsec/$(systemdsystemunitdir)/ntpsec-systemd-netif.path
	install -D -m 0644 debian/ntpsec-systemd-netif.service \
		debian/ntpsec/$(systemdsystemunitdir)/ntpsec-systemd-netif.service

ifeq (yes,$(shell dpkg-vendor --derives-from Ubuntu && echo yes))
	install -D -m 0644 debian/ntp.conf.ubuntu debian/ntpsec/etc/ntpsec/ntp.conf
else
	install -D -m 0644 debian/ntp.conf debian/ntpsec/etc/ntpsec/ntp.conf
endif
	install -D -m 0644 debian/ntpviz.conf \
		debian/ntpsec-ntpviz/etc/ntpsec/ntp.d/ntpviz.conf

	# install apparmor profile
	install -D -m 0644 debian/apparmor-profile \
		debian/ntpsec/etc/apparmor.d/usr.sbin.ntpd
	install -D -m 0644 debian/apparmor-profile.tunable \
		debian/ntpsec/etc/apparmor.d/tunables/ntpd
	dh_link -pntpsec etc/apparmor.d/usr.sbin.ntpd \

=== debian/watch ===
version=4
opts="\
    pasv,\
    compression=xz,repack,\
    dversionmangle=s/\+dfsg\d*$//,\
    oversionmangle=s/$/+dfsg1/,\
    pgpsigurlmangle=s/$/.asc/" \
  ftp://ftp.ntpsec.org/pub/releases/@PACKAGE@@ANY_VERSION@@ARCHIVE_EXT@ \
  debian debian/repack-waf

## ntpsec 1.2.3

=== debian/changelog ===
ntpsec (1.2.3-1) unstable; urgency=medium

  * New upstream release (via uupdate -v 1.2.3 with ntpsec_1.2.3+dfsg1.orig.tar.xz
    from Debian trixie/testing)
  * remove debian/patches that are already merged in new upstream version:
    - 0001-Avoid-installation-of-runtests-from-libaes_siv-test-.patch
    - 0001-Write-pidfile-in-parent.patch
    - fix-cookie-crash.patch
  * Add new patch from Debian trixie
    - downgrade-missing-stats-dir-log-severity.patch
  * refresh patch context as done in trixie
    - debian/patches/use-etc-ntpsec.patch
  * Drop --enable-debug-gdb, this was removed in NTPsec 1.2.3

 -- Arvid Requate <requate@univention.de>  Wed, 30 Oct 2024 15:55:00 +0100

ntpsec (1.2.2+dfsg1-1+deb12u1) bookworm-security; urgency=high

  * Fix cookie crash.
    Thanks to Hal Murray (Closes: 1038422)

 -- Richard Laager <rlaager@debian.org>  Sat, 29 Jul 2023 15:52:36 -0500

=== debian/rules ===
--- 
+++ 
@@ -6,7 +6,6 @@
 
 export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow,+pie
 export DEB_CFLAGS_MAINT_APPEND = -fno-strict-aliasing
-export systemdsystemunitdir = $(shell pkg-config --variable=systemdsystemunitdir systemd)
 
 %:
 	dh $@ --with apache2,python3
@@ -50,7 +49,7 @@
 		python3 waf configure \
 		--pyshebang=/usr/bin/python3 \
 		--prefix=/usr --libdir=/usr/lib/$(DEB_HOST_MULTIARCH) \
-		--enable-debug --enable-debug-gdb \
+		--enable-debug \
 		--enable-mssntp --enable-warnings \
 		--refclock=local,spectracom,generic,arbiter,nmea,pps,hpgps,shm,trimble,jjy,zyfer \
 		--enable-doc --htmldir=/usr/share/doc/ntpsec/html
@@ -79,11 +78,11 @@
 override_dh_install:
 	python3 waf install --destdir=$(CURDIR)/debian/tmp
 	mv \
-		debian/tmp/$(systemdsystemunitdir)/ntpd.service \
-		debian/tmp/$(systemdsystemunitdir)/ntpsec.service
+		debian/tmp/lib/systemd/system/ntpd.service \
+		debian/tmp/lib/systemd/system/ntpsec.service
 	mv \
-		debian/tmp/$(systemdsystemunitdir)/ntp-wait.service \
-		debian/tmp/$(systemdsystemunitdir)/ntpsec-wait.service
+		debian/tmp/lib/systemd/system/ntp-wait.service \
+		debian/tmp/lib/systemd/system/ntpsec-wait.service
 	rm -rf debian/tmp/usr/lib/python3/dist-packages/ntp/__pycache__
 	# ntpfrob probes internal, mostly undocumented settings.  It is
 	# extremely unlikely that anyone needs this.
@@ -130,19 +129,19 @@
 		debian/ntpsec.certbot \
 		debian/ntpsec/etc/letsencrypt/renewal-hooks/deploy/ntpsec
 
-	install -d debian/ntpsec/$(systemdsystemunitdir)
+	install -d debian/ntpsec/lib/systemd/system
 	install -m 644 \
 		debian/ntpsec.ntpsec-rotate-stats.service \
-		debian/ntpsec/$(systemdsystemunitdir)/ntpsec-rotate-stats.service
+		debian/ntpsec/lib/systemd/system/ntpsec-rotate-stats.service
 	install -m 644 \
 		debian/ntpsec.ntpsec-rotate-stats.timer \
-		debian/ntpsec/$(systemdsystemunitdir)/ntpsec-rotate-stats.timer
-
-	install -d debian/ntpsec-ntpviz/$(systemdsystemunitdir)
+		debian/ntpsec/lib/systemd/system/ntpsec-rotate-stats.timer
+
+	install -d debian/ntpsec-ntpviz/lib/systemd/system
 	install -m 644 \
 		etc/ntploggps.service \
 		etc/ntploggps.timer \
-		debian/ntpsec-ntpviz/$(systemdsystemunitdir)
+		debian/ntpsec-ntpviz/lib/systemd/system/
 
 	install -d debian/ntpsec-ntpviz/etc/ntpviz/day
 	install -m 644 www/day/footer \
@@ -170,15 +169,15 @@
 	install -D -m 0644 debian/ntpsec.dhcp \
 		debian/ntpsec/etc/dhcp/dhclient-exit-hooks.d/ntpsec
 	install -D -m 0755 debian/ntpsec.networkmanager \
-		debian/ntpsec/usr/lib/NetworkManager/dispatcher.d/ntpsec
+		debian/ntpsec/etc/NetworkManager/dispatcher.d/ntpsec
 	install -D -m 0644 debian/ntpsec-ntpdate.dhcp \
 		debian/ntpsec-ntpdate/etc/dhcp/dhclient-exit-hooks.d/ntpsec-ntpdate
 	install -D -m 0755 debian/ntpsec-ntpdate.networkmanager \
-		debian/ntpsec-ntpdate/usr/lib/NetworkManager/dispatcher.d/ntpsec-ntpdate
+		debian/ntpsec-ntpdate/etc/NetworkManager/dispatcher.d/ntpsec-ntpdate
 	install -D -m 0644 debian/ntpsec-systemd-netif.path \
-		debian/ntpsec/$(systemdsystemunitdir)/ntpsec-systemd-netif.path
+		debian/ntpsec/lib/systemd/system/ntpsec-systemd-netif.path
 	install -D -m 0644 debian/ntpsec-systemd-netif.service \
-		debian/ntpsec/$(systemdsystemunitdir)/ntpsec-systemd-netif.service
+		debian/ntpsec/lib/systemd/system/ntpsec-systemd-netif.service
 
 ifeq (yes,$(shell dpkg-vendor --derives-from Ubuntu && echo yes))
 	install -D -m 0644 debian/ntp.conf.ubuntu debian/ntpsec/etc/ntpsec/ntp.conf
@@ -194,3 +193,12 @@
 	install -D -m 0644 debian/apparmor-profile.tunable \
 		debian/ntpsec/etc/apparmor.d/tunables/ntpd
 	dh_link -pntpsec etc/apparmor.d/usr.sbin.ntpd \
+		etc/apparmor/init/network-interface-security/usr.sbin.ntpd
+
+	# install apport hook
+	install -D -m 644 debian/source_ntpsec.py \
+		debian/ntpsec/usr/share/apport/package-hooks/source_ntpsec.py
+
+	dh_link
+	dh_install
+
